ARC={}
ARC.name = "Alpha_ReadyCheck"
ARC.version = 1.01
ARC.tag = "ARC"
ARC.debug = false
ARC.savedVarsNum = 101


ARC.Defaults={
	["ColorBlind"] = false,
	["EnableMovement"] = false,
	["XPos"] = 0,
	["YPos"] = 0,
	["XCenter"] = 0,
	["YCenter"] = 0,
}

function ARC.Initialize(eventCode,addOnName)
	if ( addOnName ~= ARC.name ) then return end

	--event registration
	EVENT_MANAGER:UnregisterForEvent( ARC.tag , EVENT_ADD_ON_LOADED )
	EVENT_MANAGER:RegisterForEvent( ARC.tag , EVENT_MAP_PING , ARC.MapPingDetected )

	ARC.Vars = ZO_SavedVars:NewAccountWide('Alpha_VARS', ARC.savedVarsNum, nil, ARC.Defaults)


	--key bindings
	ZO_CreateStringId("SI_BINDING_NAME_I'm Ready","I'm Ready")
	--ZO_CreateStringId("SI_BINDING_NAME_I'm Not Ready","I'm Not Ready")
	ZO_CreateStringId("SI_BINDING_NAME_Ready Check", "Trigger Ready Check")
	ZO_CreateStringId("SI_BINDING_NAME_Clear Check", "Clear Ready Check")

	-- init debug
	ARC.SetDebug(ARC.debug)

	-- init ui
	--ARC.CreateScene()
	ARC.Menu:Initialize()
	ARC.Win()

end


--Debug initializer
function ARC.SetDebug(on)
  ARC.debug = on

  if on then
    if ARC.debugMsgWin then
      ARC.debugMsgWin:SetHidden(false)
    else

      -- Create the window first time debug is turned on..
      local LIBMW = LibStub:GetLibrary("LibMsgWin-1.0")
      ARC.debugMsgWin = LIBMW:CreateMsgWindow(
        "ReadyCheckDebugWindow", "ARC Debug")

    end
  elseif ARC.debugMsgWin then
    ARC.debugMsgWin:SetHidden(true)
  end
end

function ARC.DebugMsg(msg)
  if ARC.debug then
    ARC.debugMsgWin:AddText(GetTimeString() .. " " .. msg, 1, 1, 0)
  end
  return ARC.debug
end

function ARC.DebugToggle()
	if ARC.debug then
		ARC.debug = false
	else
		ARC.debug = true
	end
	ARC.SetDebug(ARC.debug)
end

EVENT_MANAGER:RegisterForEvent( ARC.tag , EVENT_ADD_ON_LOADED , ARC.Initialize )