-------------------------------------------------------------------------------
--------------------------------- VARS ----------------------------------------
-------------------------------------------------------------------------------
local activecheck = false



-------------------------------------------------------------------------------
------------------------------ Comms ------------------------------------------
-------------------------------------------------------------------------------
--Start the ready check. Only group leaders should be allowed to do this.
function ARC.RequestReadyCheck()
	ARC.DebugMsg('Player has requested a ready check!')
	if IsUnitGroupLeader('player') then
		ARC.DebugMsg('Player is group leader')
		ARC.FireReadyCheck()
	else
		ARC.DebugMsg('Player is not group leader')
		d('You are not the group leader!') --alert the player why ready check did not begin
	end
end

function ARC.FireReadyCheck()
	ARC.SendRally()
	zo_callLater(function() ARC.SendPing() end,250)
end

--ability for group leader to close the ready check for everyone
function ARC.Clear()
	ARC.DebugMsg('Clear command detected!')
	if IsUnitGroupLeader('player') then
		ARC.DebugMsg('Clearing for everyone')
		ARC.SendRally()
	else
		--can do a clear command here for everyone else to use
		ARC.Wipe()
	end
end

--ability for players to respond to the ready check
function ARC.StateReady()
	ARC.DebugMsg('Player has responded')
	ARC.SendPing()
end

function ARC.RallyDetected()
	if activecheck then
		activecheck = false
		ARC.Wipe()
	else
		activecheck = true
		ARC.StartCheck()
	end
end

function ARC.PingDetected(pingName)
	--ping name is the name of the player that placed the ping
	--first check to see if this is a ready check start
	if activecheck and IsUnitGroupLeader(pingName) then
		--handle the ready check start here
		ARC.StartCheck()
	end
	ARC.Ready(pingName)
end



-------------------------------------------------------------------------------
-------------------------------- General --------------------------------------
-------------------------------------------------------------------------------
function ARC.Ready(pingName)
	ARC.PlayerReady(pingName)
	ARC.DebugMsg(pingName .. ' is ready!')
end

function ARC.StartCheck()
	ARC.DebugMsg('Starting Ready Check')
	d('Check Food/Drink')
	d('Check Charges')
	ARC.FormRdyCheck()
end

function ARC.Wipe()
	ARC.Hide()
	ARC.DebugMsg('Clear Ready Check')
end

-------------------------------------------------------------------------------
--------------------------------- Slash Commands ------------------------------
-------------------------------------------------------------------------------
SLASH_COMMANDS["/yes"] = ARC.StateReady
SLASH_COMMANDS["/rc"] = ARC.RequestReadyCheck
SLASH_COMMANDS["/c"] = ARC.Clear
SLASH_COMMANDS["/rally"] = ARC.SendRally
SLASH_COMMANDS["/ping"] = ARC.SendPing
SLASH_COMMANDS["/arcdebug"] = ARC.DebugToggle