ARAHL={}
ARAHL.name = "Alpha_ReadyCheck"
ARAHL.version = 0.8
ARAHL.tag = "RDY_CHK"
local rdyCount = 0
local groupSize = 0
local ARAHLWinHidden = true

--Defaults
ARAHL.Defaults         ={
	["ColorBlind"] = false,
	["EnableMovement"] = false,
	["XPos"] = 0,
	["YPos"] = 0,
	["XCenter"] = 0,
	["YCenter"] = 0,
}

local groupControls = { }

local tlw = nil
local wm = GetWindowManager()

ARAHL.Menu = {}
local LAM2 = LibStub("LibAddonMenu-2.0")

function ARAHL.Menu:Initialize()
	ARAHL.Menu.panel = {
	type = "panel",
	name = ARAHL.tag,
	displayName = ARAHL.name,
	author = "AlphaRahl",
	version = ARAHL.version,
}

	LAM2:RegisterAddonPanel("Ready Check", ARAHL.Menu.panel)
	local opts = {
		[1] = {
				type = "checkbox",
				name = "ColorBlind",
				tooltip = "Check if Red-Green color blind.",
				getFunc = function() return ARAHL.Vars.ColorBlind end,
				setFunc = function(newValue) ARAHL.CBToggle(newValue) end,
			},
		[2] = {
				type = "checkbox",
				name = "Move Ready Check",
				tooltip = "Check to enable moving of the window.",
				getFunc = function() return ARAHL.Vars.EnableMovement end,
				setFunc = function(newValue) ARAHL.MoveToggle(newValue) end,
			},
	}
	LAM2:RegisterOptionControls("Ready Check", opts)

end

function ARAHL.CBToggle(value)
	ARAHL.Vars.ColorBlind = value
end

function ARAHL.MoveToggle(value)
	ARAHL.Vars.EnableMovement = value
	if value == false then
		X, Y = tlw:GetCenter()
		ARAHL.Vars.XPos = X - ARAHL.Vars.XCenter
		ARAHL.Vars.YPos = Y - ARAHL.Vars.YCenter
		ARAHL.Clear()
		tlw:SetMovable(false)
	else
		ARAHL_Show()
		tlw:SetMovable(true)
	end
end





local ARAHL_isHidden = nil
local ARAHL_isReady = true
local ARAHL_notReady = true


function ARAHL.ConfigUIinit()
	

	local readyButton = {
	type = "button",
	name = "ARC",
	tooltip = "Ready",
	func = ARAHL.ImReady,
	}

	local panelData = {
		type = "panel",
		name = "ARC",
}
	local LAM2 = LibStub("LibAddonMenu-2.0")
	LAM2:RegisterAddonPanel("ReadyCheck", panelData)
end

function ARAHL.toggleView()
	if (ARAHL_isHidden == true) then
		SetGameCameraUIMode(true)
		ARReadyCheck:SetHidden(false)
	else
		SetGameCameraUIMode(false)
		ARReadyCheck:SetHidden(true)
	end
end


function ARAHL.Initialize(eventCode,addOnName)
	if ( addOnName ~= ARAHL.name ) then return end

	EVENT_MANAGER:UnregisterForEvent( ARAHL.tag , EVENT_ADD_ON_LOADED )
	EVENT_MANAGER:RegisterForEvent( ARAHL.tag , EVENT_MAP_PING , ARAHL.MapPingDetected )

	ARAHL.Vars = ZO_SavedVars:NewAccountWide('Alpha_VARS', ARAHL.version*10, nil, ARAHL.Defaults)
	ZO_CreateStringId("SI_BINDING_NAME_I'm Ready","I'm Ready")
	ZO_CreateStringId("SI_BINDING_NAME_I'm Not Ready","I'm Not Ready")
	ZO_CreateStringId("SI_BINDING_NAME_Ready Check", "Trigger Ready Check")
	ZO_CreateStringId("SI_BINDING_NAME_Clear Check", "Clear Ready Check")
	ARAHL.Menu:Initialize()
	ARAHL.Win()
	

end

function ARAHL.MapPingDetected(eventCode, pingEventType, pingType, pingTag, offsetX, offsetY , isOwner)
	local X = ARAHL.round(offsetX)
	local Y = ARAHL.round(offsetY)
	--d("(" .. X .. "," .. Y ..")" .. pingType)
	local pName = GetUnitName(pingTag)
	if (pingType == MAP_PIN_TYPE_PING) then
		ARAHL.PingFound(pName)
	elseif (pingType == 91) then 
		ARAHL.RallyPing(GetUnitName(GetGroupLeaderUnitTag()))
	end

end

local leadPingName = ""
function ARAHL.RallyPing(pName)
	if leadPingName == pName then
		leadPingName = ""
		ARAHL_Hide()
	else
		leadPingName=pName
	end
end


function ARAHL.PingFound(pName)
	if pName == leadPingName then
		ARAHL.RCheck()
	end
	ARAHL.PlayerReady(pName)
end

function ARAHL.RCheck()
	--leader has requested ready check, display UI
	--rdyCount=0
	--groupSize = GetGroupSize()
	if (ARAHLWinHidden == true) then
		d("Ready Check!")
		d("Check Food")
		d("Check Weapon Charges")
		ARAHL_Show()
	end
end

function ARAHL.round(num)
	return (num)
end

function ARAHL_GetGroupIndex(pname)
	local groupIndex = 0
	for i = 1, GetGroupSize() do
		if (pname == GetUnitName(GetGroupUnitTagByIndex(i))) then groupIndex = i end
	end
	return groupIndex
end

function ARAHL.PlayerReady(pName)	
	if groupControls[ARAHL.GetPlayerLocation(pName)] ~= nil then
		if ARAHL.Vars.ColorBlind == false then
			groupControls[ARAHL.GetPlayerLocation(pName)]:SetColor(0,1,0,1)
		else 
			groupControls[ARAHL.GetPlayerLocation(pName)]:SetColor(0,0,1,1)
		end
	end
end

function ARAHL.PlayerNotReady(pName)
	if groupControls[ARAHL.GetPlayerLocation(pName)] ~= nil then
		if ARAHL.Vars.ColorBlind == false then
			groupControls[ARAHL.GetPlayerLocation(pName)]:SetColor(1,0,0,1)
		else
			groupControls[ARAHL.GetPlayerLocation(pName)]:SetColor(1,0.8,0,1)
		end
	end
end

function ARAHL.GetPlayerLocation(pName)
	for i = 1, table.getn(groupControls) do
		if groupControls[i]:GetName() == pName then return i end
	end
end

function ARAHL.Ping()
	PingMap(MAP_PIN_TYPE_PING, MAP_TYPE_LOCATION_CENTERED, 1,1)
end



function ARAHL.LeadPing()
	if IsUnitGroupLeader('player') then
		PingMap(91, MAP_TYPE_LOCATION_CENTERED,1,1)
		zo_callLater(function() PingMap(MAP_PIN_TYPE_PING, MAP_TYPE_LOCATION_CENTERED, 1,1) end,250)
	else
		d("You are not the group leader.")
	end
end


function ARAHL.Clear()
	if IsUnitGroupLeader('player') then
		PingMap(91, MAP_TYPE_LOCATION_CENTERED,1,1)
	else
		ARAHL_Hide()
	end
end


--Starting UI stuff here



local xdim = 300
local ydim = 50

function ARAHL.SetCenter()
	ARAHL.Vars.XCenter, ARAHL.Vars.YCenter = tlw:GetCenter()
	d(ARAHL.Vars.XCenter .. " " .. ARAHL.Vars.YCenter)
end

function ARAHL.Win()
	tlw = wm:CreateTopLevelWindow("RdyChk")
	tlw:SetDimensions(xdim,ydim)
	tlw:SetResizeToFitDescendents(true)
	tlw:SetAnchor(CENTER, GuiRoot, CENTER, 0 + ARAHL.Vars.XPos,0 + ARAHL.Vars.YPos)
	ARAHL.SetCenter()
	tlw:SetMovable(false)
	tlw:SetMouseEnabled(true)

	lbl = wm:CreateControl("lbl", tlw, CT_LABEL)
	lbl:SetColor(0.8,0.8,0.8,1)
	lbl:SetFont("ZoFontAlert")
	lbl:SetScale(1)
	lbl:SetWrapMode(TEX_MODE_CLAMP)
	lbl:SetDrawLayer(1)
	lbl:SetText("Ready Check")
	lbl:SetAnchor(TOPLEFT, tlw, nil, 0, 25-(ydim/2))
	lbl:SetDimensions(250,25)
	tlw:SetHidden(true)

end



function ARAHL_Show()
	tlw:SetHidden(false)
	ARAHL_Form_RDY_WIN()
	ARAHLWinHidden = false
end

function ARAHL_Hide()
	tlw:SetHidden(true)
	for i = 1, table.getn(groupControls) do
		groupControls[i]:SetHidden(true)
	end
	ARAHLWinHidden = true
end


function ARAHL_Form_RDY_WIN()
	for i = 1 , GetGroupSize() do 
		chk = 0
		if table.getn(groupControls) ~= nil then
			for x = 1, table.getn(groupControls) do
				if GetUnitName(GetGroupUnitTagByIndex(i)) == groupControls[x]:GetName() then
					chk = x
				end
			end
		end
		if chk > 0 then
			groupControls[chk]:SetAnchor(TOPLEFT, tlw, nil, 0, 25+(i*25))
			if ARAHL.Vars.ColorBlind == false then
				groupControls[chk]:SetColor(1,0.8,0,1)
			else
				groupControls[chk]:SetColor(0,0.5,0.5,1)
			end
			groupControls[chk]:SetHidden(false)
		else
			j = 1 + table.getn(groupControls)
			local member = wm:CreateControl(GetUnitName(GetGroupUnitTagByIndex(i)), tlw, CT_LABEL)
			if ARAHL.Vars.ColorBlind == false then
				member:SetColor(1,0.8,0,1)
			else
				member:SetColor(0,0.5,0.5,1)
			end
			member:SetFont("ZoFontAlert")
			member:SetScale(1)
			member:SetWrapMode(TEX_MODE_CLAMP)
			member:SetDrawLayer(1)
			member:SetText(GetUnitName(GetGroupUnitTagByIndex(i)))
			member:SetAnchor(TOPLEFT, tlw, nil, 0,25+(i*25))
			member:SetDimensions(250,25)
			groupControls[j] = member
		end
	end
end

SLASH_COMMANDS["/yes"] = ARAHL.Ping
SLASH_COMMANDS["/no"] = ARAHL.ImNotReady
SLASH_COMMANDS["/readycheck"] = ARAHL.LeadPing
SLASH_COMMANDS["/rc"] = ARAHL.LeadPing
SLASH_COMMANDS["/ui"] = ARAHL_Show
SLASH_COMMANDS["/c"] = ARAHL.Clear
--SLASH_COMMANDS["/gr"] = ARAHL.addMembers(GetGroupSize())

EVENT_MANAGER:RegisterForEvent( ARAHL.tag , EVENT_ADD_ON_LOADED , ARAHL.Initialize )