ARC.Menu = {}
local LAM2 = LibStub("LibAddonMenu-2.0")

function ARC.Menu:Initialize()
	ARC.Menu.panel = {
	type = "panel",
	name = ARC.tag,
	displayName = ARC.name,
	author = "AlphaRahl",
	version = ARC.version,
}

	LAM2:RegisterAddonPanel("Ready Check", ARC.Menu.panel)
	local opts = {
		[1] = {
				type = "checkbox",
				name = "ColorBlind",
				tooltip = "Check if Red-Green color blind.",
				getFunc = function() return ARC.Vars.ColorBlind end,
				setFunc = function(newValue) ARC.CBToggle(newValue) end,
			},
		[2] = {
				type = "checkbox",
				name = "Move Ready Check",
				tooltip = "Check to enable moving of the window.",
				getFunc = function() return ARC.Vars.EnableMovement end,
				setFunc = function(newValue) ARC.MoveToggle(newValue) end,
			},
	}
	LAM2:RegisterOptionControls("Ready Check", opts)

end

function ARC.CBToggle(value)
	ARC.Vars.ColorBlind = value
end

function ARC.MoveToggle(value)
	ARC.Vars.EnableMovement = value
	if value == false then
		X, Y = ARC.tlw:GetCenter()
		ARC.Vars.XPos = X - ARC.Vars.XCenter
		ARC.Vars.YPos = Y - ARC.Vars.YCenter
		ARC.Clear()
		ARC.tlw:SetMovable(false)
	else
		ARC.Show()
		ARC.tlw:SetMovable(true)
	end
end

function ARC.ConfigUIinit()
	

	local readyButton = {
	type = "button",
	name = "ARC",
	tooltip = "Ready",
	func = ARC.ImReady,
	}

	local panelData = {
		type = "panel",
		name = "ARC",
}
	local LAM2 = LibStub("LibAddonMenu-2.0")
	LAM2:RegisterAddonPanel("ReadyCheck", panelData)
end

function ARC.toggleView()
	if (ARC_isHidden == true) then
		SetGameCameraUIMode(true)
		ARReadyCheck:SetHidden(false)
	else
		SetGameCameraUIMode(false)
		ARReadyCheck:SetHidden(true)
	end
end